﻿using System.Web.Http;
using JsonApiServer.Models;
using Newtonsoft.Json;
using log4net;

namespace JsonApiServer.Controllers
{
   /// <summary>
   /// The authentication controller
   /// </summary>
   public class AuthenticateController : ApiController
   {
      private readonly ILog _log = LogManager.GetLogger(typeof(AuthenticateController));

      /// <summary>
      /// authenticate a user based on their credentials
      /// </summary>
      /// <param name="request"></param>
      /// <returns></returns>
      [HttpPost]
      public AuthenticationResult Authenticate([FromBody] AuthenticateRequest request)
      {
         AuthenticationResult result;

         _log.Debug("Authenticate user begins");
         _log.Debug("Authenticate request:" + JsonConvert.SerializeObject(request));

         // change this for your authentication
         bool isSuccess = AuthenticateUser(request.Username, request.Password);

         if (isSuccess)
         {
            result = new AuthenticationResult
            {
               Succeed = true
            };
         }
         else
         {
            result = new AuthenticationResult()
            {
               Succeed = false,
               //Message = "Your login credentials appear to be incorrect. Please try again and ensure the 'Caps Lock' is off (bw5)." //uncomment if you wish to customize this message
            };
         }

         _log.Debug("Result: " + JsonConvert.SerializeObject(result));
         _log.Debug("Authenticate user ends");

         return result;

      }

      private bool AuthenticateUser(string username, string password)
      {
         return password == "test123";
      }

      public class AuthenticateRequest
      {
         public string Username { get; set; }
         public string Password { get; set; }
      }
   }
}